import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.plugin.frame.*;
import ij.io.*;

public class Compare_Plugin implements PlugIn {

	public void run(String arg) {
		
		// Dichiarazione variabili.
		
		ImagePlus im;
		ImageProcessor ip;
		
		ImagePlus compareIm;
		ImageProcessor compareIp;
		
		ImagePlus cleanModificationIm;
		
		FileInfo fi;
		FileOpener fo;
		
		int w, h;
		
		// Fetch immagine attualmente attiva, con le sue dimensioni.
		
		im = IJ.getImage();
		ip = im.getProcessor();
		
		w = ip.getWidth();
		h = ip.getHeight();
		
		// Creazione parte destra immagine confronto, copiamo nella parte destra l'immagine già modificata dall'utente.
		
		compareIp = new ColorProcessor(w*2, h);
		compareIp.insert(ip, w+1, 0);
		
		// Ripristino stato originale immagine modificata dall'utente.
		
		cleanModificationIm = IJ.createImage("Clean", "RGB", w, h, 1);
		
		fi = im.getOriginalFileInfo();
		fo = new FileOpener(fi);
		fo.revertToSaved(cleanModificationIm);
		
		// Creazione parte sinistra immagine confronto, copiamo a sinistra l'immagine a cui sono state tolte tutte le modifiche effettuate precedentemente dall'utente.

		compareIp.insert(cleanModificationIm.getProcessor(), 0, 0);
		
		// Creazione e visualizzazione immagine confronto.
		
		compareIm = IJ.createImage("Compare", "RGB", w*2, h, 1);
		compareIm.setProcessor(compareIp);
		compareIm.show();
	}

}